Bug 880528 - JBossMarshaller can be used before properly initialized
Summary: JBossMarshaller can be used before properly initialized
Keywords:
Status: VERIFIED
Alias: None
Product: JBoss Data Grid 6
Classification: JBoss
Component: Infinispan
Version: 6.1.0
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ER6
: 6.1.0
Assignee: Tristan Tarrant
QA Contact: Martin Gencur
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-11-27 09:05 UTC by Radim Vansa
Modified: 2013-10-07 00:21 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Issue Tracker ISPN-2553 0 Major Resolved JBossMarshaller can be used before properly initialized 2013-08-15 07:53:24 UTC

Description Radim Vansa 2012-11-27 09:05:39 UTC
The JBossMarshaller can be used before its start() method is called. I've noticed that with replicated cache without transactions, an OOB thread can start demarshalling SingleRpcCommand in CacheRpcCommandExternalizer but when it tries to create a new unmarshaller (through AbstractJBossMarshaller.startObjectInput(...) and the marshallerTL.initialValue() the baseCfg configuration is not fully initialized yet and this results in creating marshallers in PerThreadInstanceHolder with objectTable == null. Then, objects are deserialized to null (which results in NullPointerExceptions elsewhere).

Comment 1 JBoss JIRA Server 2012-12-05 17:19:56 UTC
Galder Zamarreño <galder.zamarreno@redhat.com> made a comment on jira ISPN-2553

Radim, where do you see this? In JDG (which runs on top of AS7), or in standalone Infinispan usage (i.e. library)?

Comment 2 Radim Vansa 2012-12-05 17:30:16 UTC
I experience this in library mode test.

https://jenkins.mw.lab.eng.bos.redhat.com/hudson/job/jdg-radargun-resilience-repl-no-tx/4/console-edg-perf10/

But this has not TRACE logs enabled and to identify the issue I had to put more than the standard ISPN's TRACE logs. Luckily, the issue is reproducable in this test and I have been able to do reproduce it locally as well (although not always).

Comment 3 JBoss JIRA Server 2012-12-11 09:00:19 UTC
Galder Zamarreño <galder.zamarreno@redhat.com> updated the status of jira ISPN-2553 to Coding In Progress

Comment 4 JBoss JIRA Server 2012-12-11 09:57:25 UTC
Galder Zamarreño <galder.zamarreno@redhat.com> made a comment on jira ISPN-2553

Radim, I have a patch that I think solves the issue: https://github.com/galderz/infinispan/tree/t_2553

Can you give it a shot and see if it fixes the issue?

Comment 5 Radim Vansa 2012-12-11 12:20:24 UTC
I will try it, thanks.


Note You need to log in before you can comment on or make changes to this bug.